use std::io;
use std::io::Read;
use domo_proto::packet::{Packet, PACKET_HEADER_SIZE};

pub fn try_read_packet(read_handle: &mut dyn Read) -> io::Result<Packet> {
    let mut header = [0_u8; PACKET_HEADER_SIZE];
    read_handle.read(header.as_mut_slice())?;
    if header[0] != 1 {
        return Err(io::Error::new(io::ErrorKind::InvalidData, "Invalid version"));
    }
    let mut body = vec![];
    body.reserve(u16::from_be_bytes([header[0x12], header[0x13]]) as usize);
    read_handle.read_exact(&mut body)?;

    Packet::try_from({
        let mut data = vec![];
        data.extend(header);
        data.extend(body);
        data
    })
}